#
# RecordEventObserver, a helper class written by moveq
# Copyright (C) 2007-2008 moveq / Suomipoeka team (suomipoeka@gmail.com)
# In case of reuse of this source code please do not remove this copyright.
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	For more information on the GNU General Public License see:
#	<http://www.gnu.org/licenses/>.
#
from enigma import eTimer, iRecordableService	#eServiceReference, eServiceCenter
from Components.config import config
from Suomipoeka import spDebugOut
import NavigationInstance


# Suomipoeka timerlist cleanup
cleanupTimer = eTimer()
def cleanupTimerFunc():
	NavigationInstance.instance.RecordTimer.cleanup()
	cleanupTimer.stop()
cleanupTimer.timeout.get().append(cleanupTimerFunc)



gSelf = None
class RecordEventObserver:
	def __init__(self, callback):
		self.callback = callback
		global gSelf
		gSelf = self

		try:
			NavigationInstance.instance.record_event.append(self.RecEvent)
		except Exception, e:
			spDebugOut("[spRO] Record observer add exception:\n" + str(e))

	@staticmethod
	def RecEvent(recservice, event):
		try:
			if event == iRecordableService.evStart:
				spDebugOut("[spRO] REC START event for: " + str(recservice))
			elif event == iRecordableService.evEnd:
				spDebugOut("[spRO] REC STOP event for: " + str(recservice))

				if config.suomipoeka.timer_autocln.value:
					cleanupTimer.start(3000, False)	# single shot timer to clean up the timers list

			gSelf.callback(recservice, event)

		except Exception, e:
			spDebugOut("[spRO] RecEvent exception:\n" + str(e))

